/*
MarketMaker

Copyright (c) 2004 NAKAJIMA Yoshihiro
  modified TestStrategy.java( Copyright (c) 1999 Hiroshi Sato,
(c) 2000 Rikiya Fukumoto, (c) 2002 U-Mart Project)

Permission is hereby granted, free of charge, to any person obtaining
a copy of this software and associated documentation files (the 
"Software"), to deal in the Software without restriction, including 
without limitation the rights to use, copy, modify, merge, publish, 
distribute, sublicense, and/or sell copies of the Software, and to 
permit persons to whom the Software is furnished to do so, subject to
the following conditions:

The above copyright notice and this permission notice shall be 
included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, 
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY 
CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, 
TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
---------------------------------------------------------------------
 */

/* 
 AhzbNȃ}[Pbg[J[ASY
@CzƔCzoB
@ꂽ甃CzグB
  甄CzB
@
iQlj@2004N33Jasdaq@MM@i276jɂA
          Xvbh\
  @@@@XvbhF@AskPrice-LastPrice
  @@@@XvbhF@LastPrice-BidPrice
  
       A-LSpread L-BSpread Bit-Ask
MAX	8.9%     15.2%	   14.3%
MIN	-0.9%	 -3.4%	    0.2%
Average	1.4%	 1.1%	    2.5%
W΍1.5%	 1.5%	    2.0%



MODEL: 

a=0.0001
b=0.01
c=a/2

ϐ݌ɗʂƂƂA܂Ax=pos̎


Ƃ肠A3Ȑ@y=x**3 œlB

ds(x)=a1*(x**3)+b 
us(x)=-a2*(x**3)+b


̃|WVĂ鎞@肽^Ȃ@
Cz̉@@Cz̉
(|WV炷A|WV𑝂₳Ȃق挈j

if x>0 then a1>a2
if x<0 then a2>a1
āA

a1=a+c*(x/|x|)
a2=a-c*(x/|x|)

  
ds(x)=c*abs(x**3)+a*(x**3)+b Xvbh
us(x)=c*abs(x**3)-a*(x**3)+b Xvbh
askP(x)=(1+us(x))*P@ask i
bidP(x)=(1-ds(x))*P@bid i

 */

package strategy;
import java.util.*;
import java.io.*;

public class MarketMakerStrategy extends Strategy {
  private Random random;
  private String fNow;
  private FileOutputStream fMM;
  private PrintStream psfMM;

  private FileOutputStream fdb;
  private PrintStream pdb;

  private final double a=0.0001; // XvbhvŽW (3֐̌Wj
  private final double b=0.01;   // |WV[̎̃Xvbh
  private final double c=a/2.0;  // dsus̑xp[^

  private double ContractTimes=0;
  private int TotalNumberOfItayose=0;
  private double SFSpread=0;
  
  /* Constructor for Agent Initialization */
  public MarketMakerStrategy(int seed) {
    random = new Random(seed);
    fNow=String.valueOf(System.currentTimeMillis());

    try{
      fMM=new FileOutputStream("MM.d");
      psfMM= new PrintStream(fMM);

      fdb=new FileOutputStream("db.d");
      pdb= new PrintStream(fdb);

    }catch(IOException ioe){
      System.out.println("IO error in Observer.viewTwoDimensionalSpace"+ioe);
    }
  }
 
  public void action( int[] spotPrices, int[] futurePrices, int pos, long money, int restDay ) {
    Order order = new Order(); 
    int prevPrice=-10;

    if(TotalNumberOfItayose<restDay){
      TotalNumberOfItayose=restDay;
    }

    for ( int i = futurePrices.length - 1; i >= 0; --i ) {
      if ( futurePrices[i] > 0 ){
        prevPrice=futurePrices[i];
        break;
      }
    }
    
    if(prevPrice<=0){
      prevPrice = getLatestPrice( spotPrices );
    }


    double x=(double)pos;
    double lowerSpread=c*Math.abs(x*x*x)+a*(x*x*x)+b;
    double bidPrice=(1-lowerSpread)*prevPrice;
    
    double upperSpread=c*Math.abs(x*x*x)-a*(x*x*x)+b;
    double askPrice=(1+upperSpread)*prevPrice;

    order.quant=1; // MḾAxɈꖇ̒

    order.price=(int)bidPrice;
    if(order.price>0){
      order.buysell=Order.BUY;
      orderRequest(order);
    }      

    order.price=(int)askPrice;    
    if(order.price>0){
      order.buysell=Order.SELL;
      orderRequest(order);
    }      
/*
      psfMM.println(
        restDay+"\t"+
        getLatestPrice(spotPrices)+"\t"+
        prevPrice+"\t"+
        futurePrices[futurePrices.length-1]+"\t"+
        bidPrice+"\t"+
        askPrice+"\t"+
        pos+"\t"+
        money
        );
*/

    if(futurePrices[futurePrices.length-1]>0){
      ContractTimes++;
      SFSpread+=Math.abs(getLatestPrice(futurePrices)-getLatestPrice(spotPrices));
      
    }
    
      psfMM.println(ContractTimes/(TotalNumberOfItayose-restDay)+" "+SFSpread/ContractTimes+" "+((double)money)/1000000000+" "+pos);

  } // end of action
}
